using System;

namespace Arrays
{
    class Program
    {
        static void Main(string[] args)
        {

            #region Single Dimension Array
            //instantiation of a 1D array of 10 integers
            int[] numbers = new int[10];

          //fill the array with some numbers
            for (int i = 0; i < 10; i++)
                numbers[i] = i;
          //iterate through all items of the array
            Console.WriteLine("Numbers from 0 to 9 (foreach):");
            foreach (int i in numbers)
                Console.Write("{0} ", i);

            #endregion

            #region Two Dimensional Array
          //instantiation of a 2D array of 4*6 integers
            int[,] matrix = new int[4, 6];

            Console.WriteLine("\n\nMatrix 4x6 (for):");
          //fill the array with some numbers
            for (int i = 0; i < 4; i++){
                for (int j = 0; j < 6; j++){
                    matrix[i, j] = i + j * 4;
                    Console.Write("{0} ", matrix[i,j]);
                }
                Console.WriteLine();
            }

            Console.WriteLine("\nMatrix 4x6 (foreach):");
          //iterate through all items of the array
            foreach (int i in matrix)
                Console.Write("{0} ",i);

            #endregion

            #region Array of Arrays

            Console.WriteLine("\n\nPyramid (for):");
          /* initialization of a array of arrays, it holds 6 integers in three 1D arrays
           * how does the array look like?
           */ 
            int[][] pyramid = new int[][] { new int[] { 1 }, new int[] { 2, 3 }, new int[] { 4, 5, 6 } };

          //iterate through all arrays
            for (int i = 0; i < 3; i++) {
              //iterate through all items in the current array
                for (int j = 0; j < (i + 1); j++)
                    Console.Write("{0} ", pyramid[i][j]);
                Console.WriteLine();
            }

            Console.WriteLine("\nPyramid (foreach):");

          //iterate through all arrays
            foreach (int[] i in pyramid)
            {
              //iterate through all items in the current array
                foreach (int j in i)
                    Console.Write("{0} ", j);
                Console.WriteLine();
            }

            #endregion
        }
    }
}
