using System;

namespace BoxUnbox
{
    class Program
    {
        static void Main(string[] args)
        {
          //BOXING
            int i = 5;
            Object o = i;       //boxing
            Console.WriteLine("i = {0}", i.ToString());
            Console.WriteLine("o = {0} \n", o.ToString());

            o = 7;              //now i and o are independent
            Console.WriteLine("i = {0}", i.ToString());
            Console.WriteLine("o = {0} \n", o.ToString());

            i = 9;              //i and o are still independent
            Console.WriteLine("i = {0}", i.ToString());
            Console.WriteLine("o = {0} \n\n", o.ToString());

          //current types of o and i
            if (o is Object) Console.WriteLine("o is object");  //o is Object from declaration
            if (o is int) Console.WriteLine("o is int");        //o is boxed i, so it is int too
            if (i is Object) Console.WriteLine("i is object");  //i is Object, because all types are inherited from Object
            if (i is int) Console.WriteLine("i is int");        //i is int from declaration

            Console.WriteLine();

          //type of not boxed object
            Object obj = new Object();
            if (obj is Object) Console.WriteLine("obj is object");  //obj is Object from declaration
            if (obj is int) Console.WriteLine("obj is int");        //obj is not a result of boxing, so obj is NOT int

            Console.WriteLine("\n");
          
          //UNBOXING
            int j;
            j = (int)o;         //unboxing
            Console.WriteLine("i = {0}", i.ToString());
            Console.WriteLine("o = {0}", o.ToString());
            Console.WriteLine("j = {0} \n", j.ToString());

            o = 1;              //in variable j is a copy of value refered by o
            Console.WriteLine("i = {0}", i.ToString());
            Console.WriteLine("o = {0}", o.ToString());
            Console.WriteLine("j = {0} \n", j.ToString());

            j = 20;             //j and o are independent, so i and j are
            Console.WriteLine("i = {0}", i.ToString());
            Console.WriteLine("o = {0}", o.ToString());
            Console.WriteLine("j = {0} \n\n", j.ToString());

        }
    }
}
