using System;

namespace ValueRefTypes
{
    struct ValueStruct {
        public int i;
    }

    class ReferenceClass {
        public int i;
    }

    class Program
    {
        static void Main(string[] args)
        {
            int i, j;   //int is value type
            i = 5;      //i contains 5
            j = i;      //j contains 5, it is a copy of i
            Console.WriteLine("i = {0}, j = {1}", i.ToString(), j.ToString());
            j = 7;      //j contains 7, but i contains 5
            Console.WriteLine("i = {0}, j = {1} \n\n", i.ToString(), j.ToString());

            ValueStruct s1, s2;     //struct is value type
            s1.i = 5;               //s1.i contains 5
            s2 = s1;                //s2.i contains 5, it is a copy of s1
            Console.WriteLine("s1.i = {0}, s2.i = {1}", s1.i.ToString(), s2.i.ToString());
            s2.i = 7;               //s2.i contains 7, s1.i contains 5
            Console.WriteLine("s1.i = {0}, s2.i = {1} \n\n", s1.i.ToString(), s2.i.ToString());

            ReferenceClass c1, c2;  //class is reference type
            c1 = new ReferenceClass();  //new instance of ReferenceClass
            c1.i = 5;               //c1.i contains 5
            c2 = c1;                //c2.i contains 5, c2 and c1 both point to the same object
            Console.WriteLine("c1.i = {0}, c2.i = {1}", c1.i, c2.i);
            c2.i = 7;               //c2.i = 7, c1.i = 7, because c1 and c2 refers the same object
            Console.WriteLine("c1.i = {0}, c2.i = {1} \n\n", c1.i, c2.i);
        }
    }
}
